library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;

  
ENTITY A32KHzCounter_UUT IS
END A32KHzCounter_UUT;
 
ARCHITECTURE behavior OF A32KHzCounter_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT A32KHzCounter
    PORT(
         TheCounter : OUT  std_logic_vector(15 downto 0);
         ExternalADCIsEnabled : IN  std_logic;
         ADC_NOT_DATAREADY : IN  std_logic;
         Reset : IN  std_logic;
         Clk : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal ExternalADCIsEnabled : std_logic := '0';
   signal ADC_NOT_DATAREADY : std_logic := '0';
   signal Reset : std_logic := '0';
   signal Clk : std_logic := '0';

 	--Outputs
   signal TheCounter : std_logic_vector(15 downto 0);

  	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
	signal SlowClock : std_logic := '0';
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: A32KHzCounter PORT MAP (
          TheCounter => TheCounter,
          ExternalADCIsEnabled => ExternalADCIsEnabled,
          ADC_NOT_DATAREADY => ADC_NOT_DATAREADY,
          Reset => Reset,
          Clk => Clk
        );

TheMasterClock : process
begin
	clockloop: for i in 0 to 50000 loop
		clk <= NOT clk;
		wait for 4ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 
ADC_NOT_DATAREADY <= SlowClock;
TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		
		
		SlowClock <= not SlowClock;
		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';

		else
			Reset <= '0';
		end if;
		
		ExternalADCIsEnabled <= '0';
		
		if (MasterCounter > to_unsigned(12000,128)) AND (MasterCounter < to_unsigned(14000,128)) then
			ExternalADCIsEnabled <= '1';
		else
			null;
		end if;
		

	end if;
end process TheSecondClock;

END;
