--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:52:44 01/25/2012
-- Design Name:   
-- Module Name:   /home/davrot/rasmus/ADC_AMP/AD5162_SPI_UUT.vhd
-- Project Name:  Example2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: AD5162_SPI
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;
 
ENTITY AD5162_SPI_UUT IS
END AD5162_SPI_UUT;
 
ARCHITECTURE behavior OF AD5162_SPI_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT AD5162_SPI
    PORT(
         Values : IN  std_logic_vector(7 downto 0);
         Valid : IN  std_logic;
         Ready : OUT  std_logic;
         POTI_SDI : OUT  std_logic;
         POTI_CLK : OUT  std_logic;
         POTI_NOT_CS : OUT  std_logic;
         Reset : IN  std_logic;
         Clk : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal Values : std_logic_vector(7 downto 0) := (others => '0');
   signal Valid : std_logic := '0';
   signal Reset : std_logic := '0';
   signal Clk : std_logic := '0';

 	--Outputs
   signal Ready : std_logic;
   signal POTI_SDI : std_logic;
   signal POTI_CLK : std_logic;
   signal POTI_NOT_CS : std_logic;

   -- Clock period definitions
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: AD5162_SPI PORT MAP (
          Values => Values,
          Valid => Valid,
          Ready => Ready,
          POTI_SDI => POTI_SDI,
          POTI_CLK => POTI_CLK,
          POTI_NOT_CS => POTI_NOT_CS,
          Reset => Reset,
          Clk => Clk
        );
    
	 -- Clock process definitions
TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 4ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		
	
		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;

		if MasterCounter = to_unsigned(18,128) then
			Values <= NOT "10101010";
			Valid <= '1';
		else
			Values <= (others => '0');
			Valid <= '0';
		end if;
	end if;
end process TheSecondClock;

END;
