--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:39:19 08/05/2011
-- Design Name:   
-- Module Name:   /home/davrot/Zarlink_ZestET1_Basissation/AutoPollerCore_uut.vhd
-- Project Name:  Example2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: AutoPollerCore
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;
 
ENTITY AutoPollerCore_uut IS
END AutoPollerCore_uut;
 
ARCHITECTURE behavior OF AutoPollerCore_uut IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT AutoPollerCore
    PORT(
         FIFO_IS_FULL : IN  std_logic;
         INPUT_DATA : IN  std_logic_vector(15 downto 0);
         INPUT_VALID : IN  std_logic;
         OUTPUT_DATA : OUT  std_logic_vector(29 downto 0);
         OUTPUT_VALID : OUT  std_logic;
         Poll_Start : IN  std_logic;
         Poll_Active : OUT  std_logic;
         clk : IN  std_logic;
         Reset : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal FIFO_IS_FULL : std_logic := '0';
   signal INPUT_DATA : std_logic_vector(15 downto 0) := (others => '0');
   signal INPUT_VALID : std_logic := '0';
   signal Poll_Start : std_logic := '0';
   signal clk : std_logic := '0';
   signal Reset : std_logic := '0';

 	--Outputs
   signal OUTPUT_DATA : std_logic_vector(29 downto 0);
   signal OUTPUT_VALID : std_logic;
   signal Poll_Active : std_logic;
 
 	signal Counter : unsigned(10 downto 0) := (others=>'0'); 
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0');  
	signal First : std_logic := '0';
	-- Set the initial value for the page mode 
	signal StartPage : std_logic := '0';
	signal BufferSize : unsigned (7 downto 0) := to_unsigned(6,8);
	signal BufferUsed : unsigned (7 downto 0) := to_unsigned(3,8);
	
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: AutoPollerCore PORT MAP (
          FIFO_IS_FULL => FIFO_IS_FULL,
          INPUT_DATA => INPUT_DATA,
          INPUT_VALID => INPUT_VALID,
          OUTPUT_DATA => OUTPUT_DATA,
          OUTPUT_VALID => OUTPUT_VALID,
          Poll_Start => Poll_Start,
          Poll_Active => Poll_Active,
          clk => clk,
          Reset => Reset
        );

   -- Clock process definitions
TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 2ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

  TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		
		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;

		if MasterCounter = to_unsigned(10,128) then		
			Poll_Start <= '1';
		else
			Poll_Start <= '0';
		end if;
	
		-- Register 43 Read A
		if (OUTPUT_DATA = "000000000000000001010111001000") AND (OUTPUT_VALID = '1') AND (First = '0') then
			INPUT_DATA <= "0000000" & StartPage & "00100000";
			INPUT_VALID <= '1';
			First <= '1';
		-- Register 43 Read B
		elsif (OUTPUT_DATA = "000000000000000001010111001000") AND (OUTPUT_VALID = '1') AND (First = '1') then
--			-- Wrong Page 
--			INPUT_DATA <= "0000000" & ~StartPage & "00100000";
			-- Correct Response 
			INPUT_DATA <= "0000000" & StartPage & "00100000";
			INPUT_VALID <= '1';
			First <= '0';	
		-- Register 43 Write 0 
		elsif (OUTPUT_DATA = "000000000000000001010110000100") AND (OUTPUT_VALID = '1') then			
			StartPage <= '0';
			INPUT_DATA <= "0000000000010000";
			INPUT_VALID <= '1';	
		elsif (OUTPUT_DATA = "000000000000000101010110000100") AND (OUTPUT_VALID = '1') then			
			StartPage <= '1';
			INPUT_DATA <= "0000000000010000";
			INPUT_VALID <= '1';				
		elsif (OUTPUT_DATA = "000000000000000000000101001001") AND (OUTPUT_VALID = '1') AND (First = '0') then
			INPUT_DATA <= std_logic_vector(BufferSize) &"00100100";
			INPUT_VALID <= '1';	
			First <= '1';
		elsif (OUTPUT_DATA = "000000000000000000000101001001") AND (OUTPUT_VALID = '1') AND (First = '1') then
			INPUT_DATA <= std_logic_vector(BufferSize) &"00100100";
			INPUT_VALID <= '1';	
			First <= '0';
		elsif (OUTPUT_DATA = "000000000000000000000011001010") AND (OUTPUT_VALID = '1') AND (First = '0') then
			INPUT_DATA <= std_logic_vector(BufferUsed) &"00101000";
			INPUT_VALID <= '1';	
			First <= '1';
		elsif (OUTPUT_DATA = "000000000000000000000011001010") AND (OUTPUT_VALID = '1') AND (First = '1') then
			INPUT_DATA <= std_logic_vector(BufferUsed) &"00101000";
			INPUT_VALID <= '1';	
			First <= '0';
		else
			INPUT_DATA <= (others => '0');
			INPUT_VALID <= '0';
			First <= First;
		end if;
	end if;
end process;

END;
