--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:41:34 02/28/2011
-- Design Name:   
-- Module Name:   /home/davrot/ZestET1/MySPI_UUT.vhd
-- Project Name:  Example2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: DataProzessingCore
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;

 
ENTITY MySPI_UUT IS
END MySPI_UUT;
 
ARCHITECTURE behavior OF MySPI_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT DataProzessingCore
    PORT(
         SPI_ZL_CS : OUT  std_logic;
         SPI_SDI : OUT  std_logic;
         SPI_SDO : IN  std_logic;
         SPI_CLK : OUT  std_logic;
         TheInput_Data : IN  std_logic_vector(15 downto 0);
         TheInput_Valid : IN  std_logic;
         TheInput_ReadEnable : OUT  std_logic;
         TheOutput_Data : OUT  std_logic_vector(15 downto 0);
         TheOutput_WriteEnable : OUT  std_logic;
         TheOutput_Done : IN  std_logic;
         Reset : IN  std_logic;
         Clk8MHz : IN  std_logic;
         clk : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal SPI_SDO : std_logic := '0';
   signal TheInput_Data : std_logic_vector(15 downto 0) := (others => '0');
   signal TheInput_Valid : std_logic := '0';
   signal TheOutput_Done : std_logic := '0';
   signal Reset : std_logic := '0';
   signal Clk8MHz : std_logic := '0';
   signal clk : std_logic := '0';

 	--Outputs
   signal SPI_ZL_CS : std_logic;
   signal SPI_SDI : std_logic;
   signal SPI_CLK : std_logic;
   signal TheInput_ReadEnable : std_logic;
   signal TheOutput_Data : std_logic_vector(15 downto 0);
   signal TheOutput_WriteEnable : std_logic;

   -- Clock period definitions
	signal Counter : unsigned(10 downto 0) := (others=>'0'); 
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
	-- Testing Read (Mode_Schreiben = '0') or Write (Mode_Schreiben = '1')
	signal Mode_Schreiben : std_logic := '1';
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: DataProzessingCore PORT MAP (
          SPI_ZL_CS => SPI_ZL_CS,
          SPI_SDI => SPI_SDI,
          SPI_SDO => SPI_SDO,
          SPI_CLK => SPI_CLK,
          TheInput_Data => TheInput_Data,
          TheInput_Valid => TheInput_Valid,
          TheInput_ReadEnable => TheInput_ReadEnable,
          TheOutput_Data => TheOutput_Data,
          TheOutput_WriteEnable => TheOutput_WriteEnable,
          TheOutput_Done => TheOutput_Done,
          Reset => Reset,
          Clk8MHz => Clk8MHz,
          clk => clk
        );

   -- Clock process definitions
TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 4ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 
 
TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		
		if Counter < to_unsigned(10,11) then
			Clk8MHz <= Clk8MHz;
			Counter <= Counter + 1;
		else
			Clk8MHz <= NOT Clk8MHz;
			Counter <= to_unsigned(0,11);
		end if;
		
		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;
		-- GOOD Packet Type "000000" - Page 0
		if MasterCounter = to_unsigned(10,128) then
		--"10101011_11111110"
			if Mode_Schreiben = '1' then
				TheInput_Data <= "1111111100000000";
			else
				TheInput_Data <= "1011111100000000";
			end if;
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 1
		elsif MasterCounter = to_unsigned(11,128) then
			TheInput_Data <= "0010101010101011";
			TheInput_Valid <= '1';
		-- BAD Packet Type "000000" - Page 1
		elsif MasterCounter = to_unsigned(12,128) then
			TheInput_Data <= "1010101010101011";
			TheInput_Valid <= '1';
		-- BAD Packet Type "000000" - Page 0
		elsif MasterCounter = to_unsigned(13,128) then
			TheInput_Data <= "1100110100000000";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 0
		elsif MasterCounter = to_unsigned(14,128) then
		-- "10101011_11111010"
			if Mode_Schreiben = '1' then
				TheInput_Data <= "1111110100000000";
			else
				TheInput_Data <= "1011110100000000";
			end if;
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 1
		elsif MasterCounter = to_unsigned(15,128) then
			TheInput_Data <= "1110101010101011";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000001" - Page 0
		elsif MasterCounter = to_unsigned(16,128) then
		-- "00101011_11111010"
			if Mode_Schreiben = '1' then
				TheInput_Data <= "1111110100000010";
			else
				TheInput_Data <= "1011110100000010";			
			end if;
			
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000001" - Page 1
		elsif MasterCounter = to_unsigned(17,128) then
			TheInput_Data <= "1010111000101011";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000010" - Page 0
		elsif MasterCounter = to_unsigned(18,128) then
		-- "11011010"
			TheInput_Data <= "1110110100000100";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000010" - Page 0			
		elsif MasterCounter = to_unsigned(19,128) then
		-- "11111010"
			TheInput_Data <= "1111110100000100";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000011" - Page 0			
		elsif MasterCounter = to_unsigned(20,128) then
		-- "10111010"
			TheInput_Data <= "1101110100000110";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 0
		elsif MasterCounter = to_unsigned(21,128) then
			if Mode_Schreiben = '1' then
				TheInput_Data <= "1111110100000000";
			else
				TheInput_Data <= "1011110100000000";			
			end if;
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 1
		elsif MasterCounter = to_unsigned(22,128) then
			TheInput_Data <= "1010101010101011";
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 0
		elsif MasterCounter = to_unsigned(31,128) then
			if Mode_Schreiben = '1' then
				TheInput_Data <= "1111110010000000";
			else
				TheInput_Data <= "1011110100000000";
			end if;
			TheInput_Valid <= '1';
		-- GOOD Packet Type "000000" - Page 1
		elsif MasterCounter = to_unsigned(32,128) then
			TheInput_Data <= "1010101010101011";
			TheInput_Valid <= '1';
		else
			TheInput_Data <= (others => '0');
			TheInput_Valid <= '0';
		end if;
	end if;
end process TheSecondClock;


END;
