----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:30:14 12/30/2011 
-- Design Name: 
-- Module Name:    NetworkPacketCounter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;

entity NetworkPacketCounter is
    Port ( 
				CompletePacketInFIFO : out STD_LOGIC;
			
				Plus 						: in  STD_LOGIC;
				Minus 					: in  STD_LOGIC;
				
				Error_Overrun			: out STD_LOGIC;
				Error_Underrun			: out STD_LOGIC;
				Reset 					: in  STD_LOGIC;
				Clk 						: in  STD_LOGIC
			);
end NetworkPacketCounter;

architecture Behavioral of NetworkPacketCounter is

	signal Counter : unsigned (15 downto 0) := (others => '0');
	signal Error_Overrun_Buffer : STD_LOGIC := '0';
	signal Error_Underrun_Buffer : STD_LOGIC := '0';
	
begin
	Error_Overrun <= Error_Overrun_Buffer;
	Error_Underrun <= Error_Underrun_Buffer;
	
	CounterProcess: process(Reset,Clk)
	begin
		if (Reset = '1') then
			
			Counter <= (others => '0');
			CompletePacketInFIFO <= '0';
			Error_Overrun_Buffer <= '0';
			Error_Underrun_Buffer <= '0';
			
		elsif rising_edge(Clk) then
			
			-- DEFAULT:
			Counter <= Counter;
			Error_Overrun_Buffer <= Error_Overrun_Buffer;
			Error_Underrun_Buffer <= Error_Underrun_Buffer;
			
			if (Plus = '1') AND (Minus = '1') then
				NULL;
			elsif (Plus = '1') AND (Counter /= "1111111111111111") then
				Counter <= Counter + 1;
			elsif (Minus = '1') AND (Counter /= "0000000000000000") then
				Counter <= Counter - 1;
			elsif (Plus = '1') AND (Counter = "1111111111111111") then
				Error_Overrun_Buffer <= '1';
			elsif (Minus = '1') AND (Counter = "0000000000000000") then
				Error_Underrun_Buffer <= '1';
			else
				NULL;
			end if;
			
			if Counter = to_unsigned(0,16) then
				CompletePacketInFIFO <= '0';
			else
				CompletePacketInFIFO <= '1';
			end if;
			
		end if;
	end process CounterProcess;

end Behavioral;

