library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;
 
 
ENTITY TifferOut_MuxControl_UUT IS
END TifferOut_MuxControl_UUT;
 
ARCHITECTURE behavior OF TifferOut_MuxControl_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT TiggerOut_MuxControl
    PORT(
         TriggerOut_Address : OUT  std_logic_vector(4 downto 0);
         TriggerOut_Data : OUT  std_logic;
         TriggerOut_Clk : OUT  std_logic;
         TriggerChannelsOut : IN  std_logic_vector(31 downto 0);
         HalfCycle : IN  std_logic_vector(16 downto 0);
         Clk : IN  std_logic;
         Reset : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal TriggerChannelsOut : std_logic_vector(31 downto 0) := (others => '0');
   signal HalfCycle : std_logic_vector(16 downto 0) := std_logic_vector(to_unsigned(10,17));
   signal Clk : std_logic := '0';
   signal Reset : std_logic := '0';

 	--Outputs
   signal TriggerOut_Address : std_logic_vector(4 downto 0);
   signal TriggerOut_Data : std_logic;
   signal TriggerOut_Clk : std_logic;

   -- Clock period definitions
 	signal Counter : unsigned(10 downto 0) := (others=>'0'); 
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: TiggerOut_MuxControl PORT MAP (
          TriggerOut_Address => TriggerOut_Address,
          TriggerOut_Data => TriggerOut_Data,
          TriggerOut_Clk => TriggerOut_Clk,
          TriggerChannelsOut => TriggerChannelsOut,
          HalfCycle => HalfCycle,
          Clk => Clk,
          Reset => Reset
        );
TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 4ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		

		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;
		
		TriggerChannelsOut <= TriggerChannelsOut;
		
		if MasterCounter = to_unsigned(1000,128) then			
			TriggerChannelsOut <= (others => '1');
		elsif MasterCounter = to_unsigned(2000,128) then						
			TriggerChannelsOut <= "01010101010101010101010101010101";
		else
			null;
		end if;

	end if;
end process TheSecondClock;


END;
