library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;
 
ENTITY TiggerIn_MuxControl_UUT IS
END TiggerIn_MuxControl_UUT;
 
ARCHITECTURE behavior OF TiggerIn_MuxControl_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT TiggerIn_MuxControl
    PORT(
         TriggerIn_Address : OUT  std_logic_vector(4 downto 0);
         TriggerIn_Data : IN  std_logic;
         Wait_TriggerIn : IN  std_logic_vector(16 downto 0);
         TriggerChannelsIn : OUT  std_logic_vector(31 downto 0);
         Clk : IN  std_logic;
         Reset : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal TriggerIn_Data : std_logic := '1';
   signal Wait_TriggerIn : std_logic_vector(16 downto 0) := std_logic_vector(to_unsigned(10,17));
   signal Clk : std_logic := '0';
   signal Reset : std_logic := '0';

 	--Outputs
   signal TriggerIn_Address : std_logic_vector(4 downto 0);
   signal TriggerChannelsIn : std_logic_vector(31 downto 0);

 	signal Counter : unsigned(10 downto 0) := (others=>'0'); 
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: TiggerIn_MuxControl PORT MAP (
          TriggerIn_Address => TriggerIn_Address,
          TriggerIn_Data => TriggerIn_Data,
          Wait_TriggerIn => Wait_TriggerIn,
          TriggerChannelsIn => TriggerChannelsIn,
          Clk => Clk,
          Reset => Reset
        );

 TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 4ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

TheSecondClock : process(clk) 
begin
	if rising_edge(clk) then
		

		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;
	

	end if;
end process TheSecondClock;
END;
