----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:38:24 01/27/2012 
-- Design Name: 
-- Module Name:    VGA_CS_MUX - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;

entity VGA_CS_MUX is
    Port ( 
				VGA_CS_Selected : in std_logic;
				VGA_CS 		: out std_logic_vector(31 downto 0);
				VGA_SelectionValue : in std_logic_vector(7 downto 0);
				
				Reset 		: in std_logic;
				Clk 			: in std_logic
			);
end VGA_CS_MUX;

architecture Behavioral of VGA_CS_MUX is

begin

	MyCSMux : process (Reset, Clk)
	begin
		if Reset = '1' then 
			VGA_CS <= (others => '1');
		elsif rising_edge(Clk) then
			VGA_CS <= (others => '1');
		
			case VGA_SelectionValue is								
				when std_logic_vector(to_unsigned(0,8)) =>
					VGA_CS(0) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(1,8)) =>
					VGA_CS(1) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(2,8)) =>
					VGA_CS(2) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(3,8)) =>
					VGA_CS(3) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(4,8)) =>
					VGA_CS(4) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(5,8)) =>
					VGA_CS(5) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(6,8)) =>
					VGA_CS(6) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(7,8)) =>
					VGA_CS(7) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(8,8)) =>
					VGA_CS(8) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(9,8)) =>
					VGA_CS(9) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(10,8)) =>
					VGA_CS(10) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(11,8)) =>
					VGA_CS(11) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(12,8)) =>
					VGA_CS(12) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(13,8)) =>
					VGA_CS(13) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(14,8)) =>
					VGA_CS(14) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(15,8)) =>
					VGA_CS(15) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(16,8)) =>
					VGA_CS(16) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(17,8)) =>
					VGA_CS(17) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(18,8)) =>
					VGA_CS(18) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(19,8)) =>
					VGA_CS(19) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(20,8)) =>
					VGA_CS(20) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(21,8)) =>
					VGA_CS(21) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(22,8)) =>
					VGA_CS(22) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(23,8)) =>
					VGA_CS(23) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(24,8)) =>
					VGA_CS(24) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(25,8)) =>
					VGA_CS(25) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(26,8)) =>
					VGA_CS(26) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(27,8)) =>
					VGA_CS(27) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(28,8)) =>
					VGA_CS(28) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(29,8)) =>
					VGA_CS(29) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(30,8)) =>
					VGA_CS(30) <= VGA_CS_Selected;
				when std_logic_vector(to_unsigned(31,8)) =>
					VGA_CS(31) <= VGA_CS_Selected;
				when others => 
					null;
			end case;	
		end if;
	end process MyCSMux;

end Behavioral;

